
require 'cmd_point_gadget/point_gadget.rb'
require 'cmd_point_gadget/pg_inspector.rb'
require 'cmd_point_gadget/pg_shooter.rb'
require 'cmd_point_gadget/pg_exportCSV.rb'
require 'cmd_point_gadget/pg_importer.rb'
require 'cmd_point_gadget/pg_report_page.rb'

module CMD
module Point_Gadget


def self.loadToolbar

	toolbar = UI::Toolbar.new "Point Gadget"

	 cmd1 = UI::Command.new("Shoot") { shootPoint }
     cmd1.small_icon = "pg_images/shoot.jpg"
     cmd1.large_icon = "pg_images/shoot.jpg"
     cmd1.tooltip = "Shoot Points"
     cmd1.status_bar_text = "Shoot Points"
     cmd1.menu_text = "Point Shooter"
     toolbar = toolbar.add_item cmd1

     
     cmd1b = UI::Command.new("inputXYZ") { inputXYZ }
     cmd1b.small_icon = "pg_images/inputxyz.jpg"
     cmd1b.large_icon = "pg_images/inputxyz.jpg"
     cmd1b.tooltip = "Input Coordinates"
     cmd1b.status_bar_text = "Input Coordinates"
     cmd1b.menu_text = "Point Placer"
     toolbar = toolbar.add_item cmd1b
     
     toolbar.add_separator

     cmd2 = UI::Command.new("Inspect") { pointRpt }
     cmd2.small_icon = "pg_images/inspect.jpg"
     cmd2.large_icon = "pg_images/inspect.jpg"
     cmd2.tooltip = "Inspect Points"
     cmd2.status_bar_text = "Inspect"
     cmd2.menu_text = "Point Inspector"
     toolbar = toolbar.add_item cmd2
     
     cmd2b = UI::Command.new("Report") { ReportPage.new.initiatePointReport }
     cmd2b.small_icon = "pg_images/report.jpg"
     cmd2b.large_icon = "pg_images/report.jpg"
     cmd2b.tooltip = "Points Report"
     cmd2b.status_bar_text = "Report on points"
     cmd2b.menu_text = "Point Reporter"
     toolbar = toolbar.add_item cmd2b
     
	 toolbar.add_separator
  
     cmd3 = UI::Command.new("Convert") { convertCP }
     cmd3.small_icon = "pg_images/convert.jpg"
     cmd3.large_icon = "pg_images/convert.jpg"
     cmd3.tooltip = "Convert Construction Points"
     cmd3.status_bar_text = "Convert Construction Points"
     cmd3.menu_text = "Point Converter"
     toolbar = toolbar.add_item cmd3
     

     cmd4 = UI::Command.new("Update") { instanceUpdate }
     cmd4.small_icon = "pg_images/update.jpg"
     cmd4.large_icon = "pg_images/update.jpg"
     cmd4.tooltip = "Update Points"
     cmd4.status_bar_text = "Update Points"
     cmd4.menu_text = "Point Updater"
     toolbar = toolbar.add_item cmd4

     toolbar.add_separator
     
     
     cmd5 = UI::Command.new("ImportData") { TSP_FileImport.create_dialog }
     cmd5.small_icon = "pg_images/importXYZ.jpg"
     cmd5.large_icon = "pg_images/importXYZ.jpg"
     cmd5.tooltip = "Import File"
     cmd5.status_bar_text = "Import File"
     cmd5.menu_text = "Point Importer"
     toolbar = toolbar.add_item cmd5
     
	 cmd6 = UI::Command.new("exportCSV") { createCSV }
     cmd6.small_icon = "pg_images/exportCSV.jpg"
     cmd6.large_icon = "pg_images/exportCSV.jpg"
     cmd6.tooltip = "Export CSV"
     cmd6.status_bar_text = "CSV Export"
     cmd6.menu_text = "Point Exporter"
     toolbar = toolbar.add_item cmd6
     
     cmd6b = UI::Command.new("Create Linework") { createLinework }
     cmd6b.small_icon = "pg_images/createlinework.jpg"
     cmd6b.large_icon = "pg_images/createlinework.jpg"
     cmd6b.tooltip = "Create Linework"
     cmd6b.status_bar_text = "Create Linework"
     cmd6b.menu_text = "Create Linework"
     toolbar = toolbar.add_item cmd6b
     
     cmd7 = UI::Command.new("colorByLayer") { colorByLayer }
     cmd7.small_icon = "pg_images/cblayer.jpg"
     cmd7.large_icon = "pg_images/cblayer.jpg"
     cmd7.tooltip = "Color By Layer (Toggle)"
     cmd7.status_bar_text = ""
     cmd7.menu_text = "Color By Layer"
     toolbar = toolbar.add_item cmd7
     
     
     
end

unless file_loaded?(__FILE__)
	file_loaded(__FILE__)
			
		pc_menu= UI.menu("Plugins").add_submenu "Point Gadget"
		pc_menu.add_item("SET ORIGIN"){ setOrigin}
		pc_menu.add_separator
		pc_menu.add_item("SHOOT POINTS"){ shootPoint }
		pc_menu.add_item("TYPE XYZ"){ inputXYZ }
		pc_menu.add_separator
		pc_menu.add_item("INSPECT POINTS"){ pointRpt }
		pc_menu.add_item("POINT REPORT"){ ReportPage.new.initiatePointReport }
		pc_menu.add_separator
		pc_menu.add_item("CONVERT CONSTR. POINTS"){ convertCP }
		pc_menu.add_item("UPDATE POINT MARKERS"){ instanceUpdate }
		pc_menu.add_separator
		pc_menu.add_item("IMP CSV"){ TSP_FileImport.create_dialog }
		pc_menu.add_item("EXP CSV"){ createCSV }
		pc_menu.add_separator
		pc_menu.add_item("CREATE LINEWORK"){ createLinework }
		pc_menu.add_item("COLOR BY LAYER"){ colorByLayer }
	
	loadToolbar
		
end

def self.shootPoint;Sketchup.active_model.select_tool PW_Shoot.new;end
def self.pointRpt;Sketchup.active_model.select_tool PW_Report.new;end

#end of modules
end
end