module CMD
module Point_Gadget

class PW_Report
=begin	
	def activate
	 puts "Report tool has been activated"
	end
=end


	def initialize
		@PLATFORM_IS_OSX     = (Object::RUBY_PLATFORM =~ /darwin/i) ? true : false
		@PLATFORM_IS_WINDOWS = !@PLATFORM_IS_OSX
		@cursor2DLoc
		@boxsize
		@pInfo = "POINT INFORMATION"
		
		Sketchup.active_model.active_view.invalidate
  	end

  	#def onMouseMove(flags, x, y, view)
    #view.invalidate
  	#end
  	
  	
	def draw(view)
		
		if @cursor2DLoc != nil
			getBoxLength
			tlx = @cursor2DLoc[0]
			tly = @cursor2DLoc[1]
			
			boxHt = 40
			if @PLATFORM_IS_WINDOWS; boxHt = 60; end
			if @PLATFORM_IS_OSX; boxHt = 50; end
			x1 = 15+tlx; y1=tly-17;
			x2 = @boxsize+tlx; y2=tly-17;
			x3 = @boxsize+tlx; y3=tly+boxHt;
			x4 = 15+tlx; y4=tly+boxHt;
			
			screenpoint1 = Geom::Point3d.new x1, y1, 0
			screenpoint2 = Geom::Point3d.new x2, y2, 0
			screenpoint3 = Geom::Point3d.new x3, y3, 0
			screenpoint4 = Geom::Point3d.new x4, y4, 0

			box_pts = [screenpoint1,screenpoint2,screenpoint3,screenpoint4]

			view.drawing_color = "WhiteSmoke"
			view.draw2d GL_QUADS, box_pts
			view.drawing_color = "blue"
			view.draw2d GL_LINE_LOOP, box_pts
			
			xpos = tlx + 25
			ypos = tly - 10
			
			tlInfoPos = [xpos,ypos]
			view.draw_text tlInfoPos, @pInfo
			
			
		end
	end
	
	def getBoxLength
		@boxsize = 0
		x = @pInfo.split("\n")
		x.each {|s|
			if s.length > @boxsize; @boxsize = s.length; end	
		}
		if @PLATFORM_IS_WINDOWS; @boxsize = @boxsize * 7.425; end
		if @PLATFORM_IS_OSX; @boxsize = @boxsize * 6.25; end
		
	end
	
	def entitySelection(e)
		sel = Sketchup.active_model.selection
		sel.clear
		sel.add e
	end
	
	#def onLButtonDown(flags, x, y, view)
	def onMouseMove(flags, x, y, view)
		@cursor2DLoc = [x,y]
		ph = view.pick_helper
		ph.do_pick x,y
		bpick = ph.best_picked
		
		if bpick.is_a?(Sketchup::ComponentInstance) && bpick.definition.name[0..8] == "pg_Marker"
			
			entitySelection(bpick)
				
			i = rptOnPoint(bpick)
			@pInfo = i
			Sketchup::set_status_text(i)
		else
			sel = Sketchup.active_model.selection
			sel.clear
			@pInfo = ""
			@cursor2DLoc = nil
		end
		
		view.invalidate 
	end
	
		
	def rptOnPoint(sel)
		
		rtVal = ""
		if sel == nil
			rtVal = "NOTHING SELECTED"
			return rtVal
		end

		if sel.is_a?(Sketchup::ComponentInstance) && sel.definition.name[0..8] == "pg_Marker"
			s_dictionary = sel.attribute_dictionary "ptGadget"
			if s_dictionary != nil
			
				line1 = ""
				line2 = ""
				line3 = ""
				
				#for user defined origin
				origin = Sketchup.active_model.get_attribute "ptGadget", "Origin_Point", Geom::Point3d.new(0,0,0)
				transform = Geom::Transformation.new(origin)
				
				line0 = "Origin: " + origin.to_s + "\n"

				s_dictionary.each {|key,value|
					
					
					version = Sketchup.version
					if (key.to_s == "1_Pt_Dynamic") && (version.index('.') == 2)
						ptAdjusted = value.transform transform
						line1 = "Point: " + ptAdjusted.to_s + "\n"
					
					end
					
					if (key.to_s == "1_Pt_Dynamic") && (version.index('.') == 1)
			
						locStrAry = Array.new
						ptAdjusted = value.transform transform
						xyz = ptAdjusted.to_a
						xyz.each do |c|
							l = sprintf "%.4f", c 
							locStrAry << l
						end
						location = locStrAry.join(", ")
						line1 = "Point: " + location + "\n"
					end
					if key.to_s == "0_Pt_ID"; line2 = "PointID: " + value.to_s + "\n";end
					if key.to_s == "4_Pt_Feature";line3 = "Description: " + value.to_s + "\n";end
					
				}
				rtVal = line0 + line1 + line2 + line3
				return rtVal
			
			else
				rtVal << "This point marker has not been registered with the Point Gadget plugin.\nPlease use the Update tool to register the marker."
				return rtVal
			end
			
		else
			rtVal << "!! You have not selected a Point Marker !!"
			return rtVal
		end
	
	end
	
=begin
	def deactivate(view)
   		puts "Report Tool has been deactivated in view: " + view.to_s
 	end
=end

end


#end of modules
end
end

